from Aggregates import arrays_aggregates
from Aggregates import message_aggregates
from Decoder import decode_fragment

array_dictionary = {
        '6_2': 1,       '6_7': 2,
        '6_8': 10,      '6_9': 11,
        '6_11': 12,     '7': 13,
        '8_4': 14,      '8_7': 2,
        '8_9': 15,      '8_10': 11,
        '8_15': 27,     '20': 28
}

report_dictionary = { #8_9
        '0000': 16, '0001': 17, '0010': 18, '0011': 19, '0100': 20, '0101': 21, '0110': 22, '0111': 23, '1000': 24, '1001': 25, '1010': 26
    }

shape_dictionary = { #8_7
    '000': 2, '001': 3, '010': 4, '011': 5, '100': 7, '101': 9
}

def msg_type_dictionary(msg_type):
    """Zwraca zdefiniowany w message_aggregates typ wiadomości, umożliwia użycie konstruktora, w zależności od otrzymanego typu

    Args:
        msg_type: Typ wiadomości, tutaj - klucz słownika
    
    Returns:
        aggregates_dictionary[msg_type]: Zwraca typ wiadomości
    """
    aggregates_dictionary = {
            '1': message_aggregates.messageType_1,
            '2': message_aggregates.messageType_2,
            '3': message_aggregates.messageType_3,
            '4': message_aggregates.messageType_4,
            '5': message_aggregates.messageType_5,
            '6_1': message_aggregates.messageType_6_1,
            '6_2': message_aggregates.messageType_6_2,
            '6_3': message_aggregates.messageType_6_3,
            '6_4': message_aggregates.messageType_6_4,
            '6_5': message_aggregates.messageType_6_5,
            '6_6': message_aggregates.messageType_6_6,
            '6_7': message_aggregates.messageType_6_7,
            '6_8': message_aggregates.messageType_6_8,
            '6_9': message_aggregates.messageType_6_9,
            '6_10': message_aggregates.messageType_6_10,
            '6_11': message_aggregates.messageType_6_11,
            '6_12': message_aggregates.messageType_6_12,
            '6_13': message_aggregates.messageType_6_13,
            '6_14': message_aggregates.messageType_6_14,
            '6_15': message_aggregates.messageType_6_15,
            '7': message_aggregates.messageType_7,
            '8_1': message_aggregates.messageType_8_1,
            '8_2': message_aggregates.messageType_8_2,
            '8_3': message_aggregates.messageType_8_3,
            '8_4': message_aggregates.messageType_8_4,
            '8_5': message_aggregates.messageType_8_5,
            '8_6_1': message_aggregates.messageType_8_6_1,
            '8_6_2': message_aggregates.messageType_8_6_2,
            '8_7': message_aggregates.messageType_8_7,
            '8_8': message_aggregates.messageType_8_8,
            '8_9': message_aggregates.messageType_8_9,
            '8_10': message_aggregates.messageType_8_10,
            '8_11': message_aggregates.messageType_8_11,
            '8_12': message_aggregates.messageType_8_12,
            '8_13': message_aggregates.messageType_8_13,
            '8_14': message_aggregates.messageType_8_14,
            '8_15': message_aggregates.messageType_8_15,
            '8_16': message_aggregates.messageType_8_16,
            '9': message_aggregates.messageType_9,
            '10': message_aggregates.messageType_10,
            '11': message_aggregates.messageType_4,
            '12': message_aggregates.messageType_12,
            '13': message_aggregates.messageType_13,
            '14': message_aggregates.messageType_14,
            '15': message_aggregates.messageType_15,
            '16': message_aggregates.messageType_16,
            '17': message_aggregates.messageType_17,
            '18': message_aggregates.messageType_18,
            '19': message_aggregates.messageType_19,
            '20': message_aggregates.messageType_20,
            '21': message_aggregates.messageType_21,
            '22': message_aggregates.messageType_22,
            '23': message_aggregates.messageType_23,
            '24_A': message_aggregates.messageType_24_A,
            '24_B': message_aggregates.messageType_24_B,
            '25_11': message_aggregates.messageType_25,
            '25_10': message_aggregates.messageType_25,
            '25_01': message_aggregates.messageType_25,
            '25_00': message_aggregates.messageType_25,
            '26_11': message_aggregates.messageType_26,
            '26_10': message_aggregates.messageType_26,
            '26_01': message_aggregates.messageType_26,
            '26_00': message_aggregates.messageType_26,
            '27': message_aggregates.messageType_27
        }

    return aggregates_dictionary[msg_type]

def array_type_dictionary(array_type):
    """Zwraca zdefiniowany w array_aggregates typ tablicy, umożliwia użycie konstruktora, w zależności od otrzymanego typu

    Args:
        array_type: Typ tablicy, tutaj - klucz słownika
    
    Returns:
        return arrays[array_type]: Zwraca typ tablicy
    """
    arrays = {
        1 : arrays_aggregates.imo236_tidal,
        2 : arrays_aggregates.circle_or_point,
        3 : arrays_aggregates.rectangle,
        4 : arrays_aggregates.sector,
        5 : arrays_aggregates.polyline,
        6 : arrays_aggregates.polyline_waypoint,
        7 : arrays_aggregates.polygon,
        8 : arrays_aggregates.polygon_vertices,
        9 : arrays_aggregates.associated_text,
        10 : arrays_aggregates.cargo,
        11 : arrays_aggregates.waypoint,
        12 : arrays_aggregates.imo289_tidal,
        13 : arrays_aggregates.destinationMMSI,
        14 : arrays_aggregates.target,
        15 : arrays_aggregates.report,
        16 : arrays_aggregates.siteLocationPayload,
        17 : arrays_aggregates.stationIdPayload,
        18 : arrays_aggregates.windPayload,
        19 : arrays_aggregates.waterLevelPayload,
        20 : arrays_aggregates.currentFlow2dPayload,
        21 : arrays_aggregates.currentFlow3dPayload,
        22 : arrays_aggregates.horizontalCurrentFlowPayload,
        23 : arrays_aggregates.seaStatePayload,
        24 : arrays_aggregates.salinityPayload,
        25 : arrays_aggregates.weatherPayload,
        26 : arrays_aggregates.airGapPayload,
        27 : arrays_aggregates.gauge,
        28 : arrays_aggregates.reservedSlot
    }

    return arrays[array_type]

def field_type_dictionary(fragment, field_type):
    """Wywołuje odpowiednią funkcję z decode_fragment w zależności od typu przetwarzanego fragmentu

    Args:
        fragment: Obecnie przetwarzany fragment wiadomości
        field_type: Typ wiadomości (klucz słownika)
    
    Returns:
        type_dictionary[field_type]: Zwraca dane w postaci odpowiedniej dla wywołanej metody (def. w decode_fragment)
    """
    type_dictionary = {
        'u': decode_fragment.decode_u_int(fragment),
        'e': decode_fragment.decode_u_int(fragment),
        'b': decode_fragment.decode_u_int(fragment),
        't': decode_fragment.decode_t(fragment),
        'x': 'NULL',
        's': decode_fragment.decode_s_int(fragment),
        'I1': decode_fragment.decode_IX(fragment, 1),
        'I2': decode_fragment.decode_IX(fragment, 2),
        'I3': decode_fragment.decode_IX(fragment, 3),
        'I4': decode_fragment.decode_IX(fragment, 4),
        'U1': decode_fragment.decode_UX(fragment, 1),
        'U2': decode_fragment.decode_UX(fragment, 2),
        'd': "Binary Data",
        'z': "",      ## typ pomocniczy, niepojawiający się w specyfikacji AIVDM
        'y': fragment ## typ pomocniczy, niepojawiający się w specyfikacji AIVDM
    }
   
    return type_dictionary[field_type]

