dataBitlengths = "slownik_krotek_z_message_aggregates"
# Dostaję wiadomość, której typ "ogólny" znam

# Niektóre typy wymagają specjalnego podejścia; są to typy, które:
#   a) różnią się "wewnętrznie" (np. typ 24 A/B) zależnie od niektórych pól - trzeba zastosować podejście "podejrzyj i dostosuj"
#   b) mają tablicę (string, czyli pole typu "t", ale o zmiennej długości, znajdujące się na końcu można uznać za szczególny przypadek
#       tablicy)
#   c) wiadomości o potencjalnie krótszej zawartości (16 i 17)
#   [d)] są zakończone nieinterpretowanymi danymi binarnymi (17) - problem załatwiony inaczej niż a - c

# Rozwiązanie problemów a - c: listy z wymienionymi tablicami, które wymagają specjalnego traktowania; zdefiniowane na sztywno
# w jakimś pliku lub na samej górze programu dekodera

need_adjustment = ["8_6", "24", ...]
has_array = ["6_2", "6_8", ...]
shorter_than_expected = ["16", "17"]             # pozdro dla kumatych

# Co robię po kolei z otrzymanym słownikiem (mam pola "type" i "payload") --- tak naprawdę "message", a nie payload, ale to się zmieni
# a message to będzie cały słownik (albo bin_message)

# funkcja decode_message wywoływana w mainie
def decode_message(message):
    if message["type"] in need_adjustment:
        adjust_message(message)
    
    mainfields_bitstrings = split_to_fields(message)
    dataParts = decode_bitstrings(mainfields_bitstrings)

    if message["type"] in has_array:
        bin_array = extract_array(message)
        fields_array = decode_array(bin_array)

    #decoded_message = slownik[message["type"]](dataParts)
        






















def adjust_message(message):
    # if-else po typach i odpowiednie dostosowanie
    pass

def split_to_fields(fields_chunk, type):
    # wykorzystanie krotki z długościami - podzielenie długiego ciągu
    # na kilka podciągów
    pass

def decode_bitstrings(bitstrings, type):
    # wykorzystaj krotkę z typami danych
    # którą? to powie parametr type
    pass

def extract_array(message):
    # wykorzystaj krotkę z długościami pól "nietablicowych" (ich sumaryczną długość)
    # wykorzystaj typ wiadomości, np.
    type = message["type"]
    offset = sum(list(dataBitlengths[type]))
    # hokus pokus wyciągnij tyle bitów ile trzeba, wyodrębnij
    # bitowe elementy tablicy (np. po 17 bitów)
    # to jeszcze nie jest podział na pola!

def decode_array(bin_array):
    decoded = []
    for element in bin_array:
        jakis_typ = "jakis_typ"
        element_bin_fields = split_to_fields(element, jakis_typ)
        fields = decode_bitstrings(element_bin_fields, jakis_typ)
        decoded.append(fields)
    return decoded